package tk.to_p.blankedoutbox.garlicclone.core;

/**
 * Tetrimino (a piece)
 */
public class TetriMinos {
	/** Tetrimino ID */
	public int type_;

	/** Blocks of the Tetrimino */
	public TetriMino[] tetriMinos_;

	/**
	 * Constructor
	 * @param type Tetrimino ID
	 */
	public TetriMinos(int type) {
		this.type_ = type;
		tetriMinos_ = new TetriMino[GarlicConst.FaceType_Count];

		for(int i = 0; i < tetriMinos_.length; i++) {
			tetriMinos_[i] = new TetriMino();
			tetriMinos_[i].type_ = type;
			tetriMinos_[i].face_ = i;

			tetriMinos_[i].minos_ = new Mino[GarlicConst.Tetri];
			for(int j = 0; j < tetriMinos_[i].minos_.length; j++)
				tetriMinos_[i].minos_[j] = new Mino();
		}
	}

	/**
	 * Blocks of the Tetrimino<br>
	 * [Anonymous class]
	 */
	public static class TetriMino {
		/** Tetrimino ID */
		public int type_ = GarlicConst.TetriminoType_None;

		/** Face */
		public int face_ = GarlicConst.FaceType_North;

		/** Minos */
		public Mino[] minos_ = null;

		/** Minimum X position */
		public int xMin_ = 0;

		/** Maximum X position */
		public int xMax_ = 0;
	}
}
